program C35;            (*Na ovladanie modemu a mobilneho telefonu Siemens C35*)

{$M $A000,$0000,$A000}

{$G+,A+,X+,Q-,N-,E-,F-,S-,R-,B-,V-,I-,C-,Y-,T-,P-,D+,L+}        (*S+ kontrola zasobnika sposobuje pad systemu ....*)

{$DEFINE MOBILx}
{$DEFINE PROCESSOR}
{$DEFINE ENGLISH}
{$DEFINE STACK}
{$DEFINE DATE}
{$DEFINE TIME}
{$DEFINE IRQ}
{$DEFINE LED}

{ATV0 spravy od modemu ako cislo}
{ATV1 spravy od modemu ako text}
{ATE0-1 echo off-on}
{AT+FCLASS=0,1,2 pri prikaza ATA zdvihne ako modem,voice?,fax}

Uses Dos,Crt,Strings;

(*****************************************************************************************************************************)
var   Old_Int_1Ch : procedure;                     (*Radsej ako vektor INT 08h t.j. 55ms*)
      Old_Int_08h : procedure;
      TabIntVec   : array [$00..$0F] of procedure; (*Tabulka kde su uschovane vsetky vektory prerusenia pre COMx a IRQx*)
      LED         : word absolute $0040:$0017;     (*Premenna BIOSu*)
      COM         : word;                          (*S ktorym portom pracujem ?*)
      IRQ         : byte;
      Speed       : longint;                       (*Obsahuje komunikacnu rychlost modemu*)
(*****************************************************************************************************************************)
const ScrollLock  : word    = $10;                 (*Klavesa Scroll Lock*)
      NumLock     : word    = $20;                 (*Klavesa Num Lock*)
      CapsLock    : word    = $40;                 (*Klavesa Caps Lock*)
      DTR         : byte    = $01;                 (*Data Terminal Ready*)
      RTS         : byte    = $02;                 (*Request Transmit Send*)
      DLAB        : byte    = $80;                 (*Bit urcujuci funkciu portu delitel-datovy port*)
      EOI         : byte    = $20;                 (*End Of Interrupt*)
      Zero        : byte    = $00;                 (*Cislo parametra prikazoveho na prikazovom riadku*)
      One         : byte    = $01;                 (*Cislo parametra prikazoveho na prikazovom riadku*)
      Two         : byte    = $02;                 (*Cislo parametra prikazoveho na prikazovom riadku*)
      Tree        : byte    = $03;                 (*Cislo parametra prikazoveho na prikazovom riadku*)
(*****************************************************************************************************************************)
type  Retazec     = string [40];
(*****************************************************************************************************************************)
type  Flag        = (Busy,Free,None,Error);     (*Definicia vysledkov hodnot premennej Flag*)
var   Semafor     : Flag;                       (*Priznak volnosti pri vnorenom preruseni... *)
      Flag_Count  : Flag;
      Dos_Busy    : ^byte;                      (*Priznak volnosti DOSu pri vykonavani nebezpecnych operaciach ... *)
(*****************************************************************************************************************************)
type  Screen      = array  [0..79,0..24] of word;       (*Architektura obrazovkovej pamati*)
var   New_Scr     : Screen absolute $B800:$0000;        (*Obrazovka VGA od $B800:$0000*)
      Old_Scr     : Screen;                             (*Uchovana stara obrazovka ale len ako pointer ...*)
      Temp_X      : byte;
      Temp_Y      : byte;
      Answer      : Retazec;                            (*Odpoved od modemu po vykonani AT prikazu*)
(*****************************************************************************************************************************)
{$IFDEF TIME}
var   Hod,Min,Sek : byte;
      Counter     : byte;
      VideoMode   : byte absolute $0040:$0049;  (*Test na farebny graficky adapter VGA na adrese $B800:$0000*)
{$ENDIF}
(*****************************************************************************************************************************)

{$IFDEF PROCESSOR}

{$L CPU.OBJ}

{$F+}

function CPU_ID    : word;    external;                 (*Zistujem typ processora*)
function FPU_ID    : word;    external;                 (*Zistujem typ koprocessora*)
function Protected : boolean; external;                 (*Zistujem mod processora ...*)

{$F-}

{$ENDIF}

{$IFDEF IRQ}

{$F+}

procedure New_Int_0Xh(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP:word); interrupt;
var Znak : char;
begin
     asm
        pushf
     end;
     Semafor:=Busy;
     Znak:=Char(Port[COM]);     (*Precitany znak z portu*)
     Answer:=Answer+Znak;       (*Tu sa sklada odpoved od modemu*)
     Write(Znak);               (*Pri prijati znaku z COM1 az COM4 vyvola prerusenie*)
     Semafor:=Free;
     Port[$20]:=EOI;            (*EOI signal konca prerusenia End Of Interrupt*)
end;

procedure Enable_Interrupt(Adresa:word;IRQ:byte);       (*Funguje spravne len s COM2 a neviem preco ....*)
var i,Mask : byte;
begin
     asm
        cli
     end;
     Port[Adresa+3]:=Port[Adresa+3] and not DLAB;       (*DLAB=0*)
     Port[Adresa+1]:=$01;                               (*Povolenie prerusenia od seriovej linky a prijatia platneho byte*)
     i:=Port[Adresa+5];
     i:=Port[Adresa];
     i:=Port[$21];                                      (*Citam stav 8259*)
     Mask:=(1 shl IRQ) xor $FF;                         (*Povolenie IRQ3a IRQ4 zapisanim 0 do 8259*)
     Port[$21]:=i and Mask;
     Port[Adresa+1]:=Port[Adresa+1] or $01;             (*Povolenie prerusenia len na prijate znaky ...*)
     i:=Port[Adresa+4];
     Port[Adresa+4]:=i or $0B;                          (*0Bh nastavenie signalov modemu*)
     asm
        sti
     end;
     Port[$20]:=EOI;                                    (*EOI signal konca prerusenia End Of Interrupt*)
end;

procedure Disable_Interrupt(Adresa:word;IRQ:byte);
var i,Mask : byte;
begin
     asm
        cli
     end;
     i:=Port[$21];                                      (*Citam stav 8259*)
     Mask:=(1 shl IRQ);                                 (*Zapisom 1 do 8259 zabezpecim vypnutie prerusenia od IRQx*)
     Port[$21]:=i or Mask;                              (*Vypinam prerusenie zapisom do 8259*)
     Port[Adresa+2]:=$00;                               (*Idendifikacny register prerusenia povel zakaz prerusenia*)
     Port[Adresa+4]:=Port[Adresa+4] and $01;            (*Vymazem bit D0 nastavenia signalov modemu*)
     asm
        sti
     end;
     Port[$20]:=EOI;                                    (*EOI signal konca prerusenia End Of Interrupt*)
end;

{$ENDIF}

{$F+}

{$IFDEF TIME}

procedure New_Int_08h(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP:word); interrupt;
begin
     asm
        pushf
     end;
     Old_Int_08h;
     if (Semafor=Free) and (Dos_Busy^=0) then
        begin
             Inc(Counter);
             if Counter>=18 then begin Inc(Sek); Counter:=0; Flag_Count:=Free; end;
        end;
end;

{$ENDIF}

{$IFDEF LED}

{$F+}

procedure New_Int_1Ch(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP:word); interrupt;
begin
     asm
        pushf
     end;
     Old_Int_1Ch;
     if (Semafor=Free) and (Dos_Busy^=0) then LED:=LED xor ScrollLock; (*Ak som volny, mozem blikat LED-kou*)
end;

{$F-}

{$ENDIF}

{$F-}                                                   (*Tato direktiva musi byt NEAR, inac to nefunguje spravne HexStr*)

function HexStr(var Number; ByteSize:byte):string; near;(*Prevod cisla do hexa-sustavy, musi byt prelozena direktivou F- !!!*)
var Result : ^string;                                   (*Ulozeny vysledok funkcie ...*)
begin
     asm
{$IFDEF STACK}
        push ax
        push bx
        push cx
        push dx
{$ENDIF}
        push ds
        push si
        push es
        push di
        push bp
        les di,dword ptr ss:[Result]            (*V ES:DI adresa vysledku, ktory ma typ retazec*)
        lds si,dword ptr ss:[Number]            (*V DS:SI prevadzane cislo*)
        mov al,byte ptr ss:[ByteSize]           (*Velkost prevadzaneho cisla do AL*)
        xor ah,ah                               (*AH:=00h*)
        mov cx,ax                               (*CX:=AX*)
        add si,ax                               (*SI:=SI+AX*)
        dec si                                  (*SI:=SI-01h*)
        shl ax,01h                              (*AX:=AX*02h*)
        cld                                     (*Nulujem priznak smeru spracovania retazcov*)
        stosb                                   (*Ukladam do cieloveho retazca na adresu urcenu ES:DI velkost v byte*)
@Cykl:  std                                     (*Nastavujem priznak smeru spracovania retazcov*)
        lodsb                                   (*Presuvam retazec urceny DS:SI do AL, AL:=DS:[SI]*)
        mov ah,al                               (*AH:=AL*)
{$IFOPT G-}
        shr al,01h                              (*AH:=AL/02h*)
        shr al,01h                              (*AH:=AL/02h*)
        shr al,01h                              (*AH:=AL/02h*)
        shr al,01h                              (*AH:=AL/02h*)
{$ELSE}
        shr al,04h                              (*AH:=AL/10h*)
{$ENDIF}
        add al,90h                              (*Specialna sekvencia prevodu na hexadecimalne cislo*)
        daa                                     (*s pouzitim ADDs a DAA's*)
        adc al,40h
        daa                                     (*Nibble je teraz prevadzany na ASCII*)
        cld                                     (*Nulujem priznak smeru spracovania retazcov*)
        stosb                                   (*Ukladam ASCII na adresu urcenu ES:DI*)
        mov al,ah                               (*Opakujem prevod pre nizsii nibble*)
        and al,0Fh
        add al,90h
        daa
        adc al,40h
        daa
        stosb
        loop @Cykl                              (*Opakujem, pokial neskoncim*)
        pop bp
        pop di
        pop es
        pop si
        pop ds
{$IFDEF STACK}
        pop dx
        pop cx
        pop bx
        pop ax
{$ENDIF}
     end;
     HexStr:=Result^;
end;

function Dos_Free:pointer;
var R : Registers;
begin
     R.AH:=$34;                                         (*Zisti priznak volnosti DOSu*)
     MsDos(R);                                          (*Vyvolam prerusenie INT 21h*)
     Dos_Free:=Ptr(R.ES,R.BX);                          (*Adresa priznaku volnosti ako vysledok ...*)
end;

procedure Init_Port(Adresa:word;Rychlost:longint);
const  XTAL : longint = 1843200;
begin
     Port[Adresa+3]:=Port[Adresa+3] or DLAB;            (*Nastavim D7 v porte 3FBh pre nastavenie prenosovej rychlosti*)
     Port[Adresa+0]:=Lo(XTAL div (Rychlost*$10));       (*Nastavim nizsi byte delitela*)
     Port[Adresa+1]:=Hi(XTAL div (Rychlost*$10));       (*Nastavim vyssi byte delitela*)
     Port[Adresa+3]:=Port[Adresa+3] and not $60;        (*Zrusim trvale vysielanie BREAK znaku*)
     Port[Adresa+3]:=Port[Adresa+3] and not $18;        (*Parita ziadna*)
     Port[Adresa+3]:=Port[Adresa+3] and not $04;        (*Jeden stop bit*)
     Port[Adresa+3]:=Port[Adresa+3] or $03;             (*8 bitov*)
     Port[Adresa+3]:=Port[Adresa+3] and not DLAB;       (*Nulujem D7 v porte 3FBh*)
     Port[Adresa+4]:=Port[Adresa+4] or DTR;             (*Nastavim LED DTR=1 na modeme co umoznuje vysielanie vzdial. modemu*)
end;

procedure Send(Adresa:word;Retazec:Retazec);
var i : word;
begin
     Port[Adresa+4]:=Port[Adresa+4] and not DTR;           (*Zabezpecim aby DTR=0 aby som pri odosielani neprijmal ...*)
     Port[Adresa+4]:=Port[Adresa+4] or RTS;                (*Povolim vysielanie a predtym som zakazal prijem ...*)
     for i:=1 to Length(Retazec) do
         begin
              Repeat Until (Port[Adresa+5] and $20)=$20;   (*Vysielam pretoze D5 je 1*)
              Port[Adresa]:=Ord(Retazec[i]);
         end;
end;

procedure Logo;
var Retazec : string;
function Align(Retazec:string):byte;
begin
     Align:=(40-(Length(Retazec) div 2)); end;
begin
     TextBackGround(LightRed);
     TextColor(LightCyan);
{$IFDEF ENGLISH}
     Retazec:='Copyright (c) 2003, All Rights Reserved for Diversant Software';
{$ELSE}
     Retazec:='Copyright (c) 2003, Vsetky prava uvedene pre Diversant Software';
{$ENDIF}
     GotoXY(Align(Retazec),1);
     WriteLn(Retazec);
{$IFDEF ENGLISH}
     Retazec:='Ing. Eduard Jadron, Jilemnickeho 37/46, 03601 MARTIN, Slovak Republic';
{$ELSE}
     Retazec:='Ing. Eduard Jadron, Jilemnickeho 37/46, 03601 MARTIN, Slovenska republika';
{$ENDIF}
     GotoXY(Align(Retazec),2);
     WriteLn(Retazec);
     Retazec:='    M O D E M - T E R M I N A L    ';
     GotoXY(Align(Retazec),3);
     TextColor(LightGreen);
     TextBackground(LightBlue);
     WriteLn(Retazec);
     WriteLn;
     TextBackGround(Black);
     TextColor(Yellow);
end;

function Exist_Str(SubStr,Retazec:string):boolean;
begin
     if Pos(SubStr,Retazec)=0 then Exist_Str:=False else Exist_Str:=True;
end;

function Erase_Str(SubStr,Retazec:string):string;
begin
     while Exist_Str(SubStr,Retazec)=True do
           begin
                Delete(Retazec,Pos(SubStr,Retazec),Length(SubStr));
           end;
     Erase_Str:=Retazec;
end;

function Change_Str(Old_Str,New_Str,Retazec:string):string;
var Index : byte;
begin
     while Exist_Str(Old_Str,Retazec)=True do
           begin
                Index:=Pos(Old_Str,Retazec);
                Delete(Retazec,Index,Length(Old_Str));
                Insert(New_Str,Retazec,Index);
           end;
     Change_Str:=Retazec;
end;

function Upper(Retazec:string):string;
type Ret  = array [0..255] of char;
var  PRet : ^Ret;
begin
     GetMem(PRet,SizeOf(PRet^));         (*Alokujem miesto na halde pre premennu*)
     StrPCopy(PRet^,Retazec);
     Upper:=StrPas(StrUpper(PRet^));
     FreeMem(PRet,SizeOf(PRet^));        (*Uvolnim miesto na halde ...*)
end;

function Lower(Retazec:string):string;
type Ret  = array [0..255] of char;
var  PRet : ^Ret;
begin
     GetMem(PRet,SizeOf(PRet^));         (*Alokujem miesto na halde pre premennu*)
     StrPCopy(PRet^,Retazec);
     Lower:=StrPas(StrLower(PRet^));
     FreeMem(PRet,SizeOf(PRet^));        (*Uvolnim miesto na halde ...*)
end;

{$IFDEF PROCESSOR}

{$F+}

function Zisti_CPU:Retazec;
begin
     Case CPU_ID of
          $0 : Zisti_CPU:='8086/88';
          $1 : Zisti_CPU:='186';
          $2 : Zisti_CPU:='NEC V20/V30';
          $3 : Zisti_CPU:='286';
          $4 : Zisti_CPU:='386SX';
          $5 : Zisti_CPU:='386DX';
          $6 : Zisti_CPU:='486SX';
          $7 : Zisti_CPU:='486DX';
          $8 : Zisti_CPU:='Pentium I';
          $9 : Zisti_CPU:='Pentium II';
          $A : Zisti_CPU:='AMD Athlon K7';
     else
         Zisti_CPU:='Unknown CPU ...';
     end;
end;

function Zisti_NPU:Retazec;
const Emul = 'Emulator ';
begin
     Case FPU_ID of
          0 : Zisti_NPU:='NPU none, ';
          1 : Zisti_NPU:='8087';
          2 : Zisti_NPU:='287';
          3 : if CPU_ID=4 then Zisti_NPU:='387SX' else Zisti_NPU:='387DX';
          4 : Zisti_NPU:='487DX';
          5 : Zisti_NPU:='587DX';
          6 : Zisti_NPU:=Emul+'287';
          7 : if CPU_ID=4 then Zisti_NPU:=Emul+'387SX' else Zisti_NPU:=Emul+'387';
          8 : if CPU_ID=6 then Zisti_NPU:=Emul+'487SX' else Zisti_NPU:=Emul+'487';
     else
         Zisti_NPU:='Unknown NPU ...';
     end;
end;

function Zisti_Protect:Retazec;
begin
{$IFDEF ENGLISH}
     if CPU_ID>2 then if Protected then Zisti_Protect:='Protected, or V86 mode' else Zisti_Protect:='Real mode';
{$ELSE}
     if CPU_ID>2 then if Protected then Zisti_Protect:='Chranenom, alebo v mode V86' else Zisti_Protect:='Realnom mode';
{$ENDIF}
end;

{$F-}

{$ENDIF}

procedure Zisti_COM(var COM:word;var IRQ:byte; var Speed:longint);
type  COM_Assign     = (COM1,COM2,COM3,COM4);             (*Definicia pola, kde sa odkazujem na datovu oblast BIOSu COMx*)
      LPT_Assign     = (LPT1,LPT2,LPT3);                  (*Definicia pola, kde sa odkazujem na datovu oblast BIOSu COMx*)
      IRQ_Assign     = (IRQ0,IRQ1,IRQ2,IRQ3,IRQ4,IRQ5,IRQ6,IRQ7);
type  COM_Pole       = array [COM1..COM4] of word;        (*Definicia pola adries COM portov*)
      LPT_Pole       = array [LPT1..LPT3] of word;        (*Definicia pola adries LPT portov*)
var   COM_Addr       : COM_Pole absolute $0040:$0000;     (*Bazova adresa COM portov*)
      LPT_Addr       : LPT_Pole absolute $0040:$0008;     (*Bazova adresa LPT portov*)
      COMi           : COM_Assign;
      LPTi           : LPT_Assign;
      IRQi           : IRQ_Assign;
      COM_tmp        : string[1];
      LPT_tmp        : string[1];
      IRQ_tmp        : string[1];
      COMx,LPTx,IRQx : Retazec;
      Code           : integer;                           (*Premenna pre funkciu VAL*)
{$IFDEF ENGLISH}
const DosVer         : string = 'MSDOS version: ';
{$ELSE}
const DosVer         : string = 'MSDOS verzia: ';
{$ENDIF}
procedure Ciarky;
begin
     WriteLn('------------------------------------------------------------------------');
end;
begin
     Ciarky;
{$IFDEF ENGLISH}
     WriteLn('Found COM or LPT port at addres:');
{$ELSE}
     WriteLn('Nasiel som porty COM a LPT na adresach:');
{$ENDIF}
     Ciarky;
     for COMi:=COM1 to COM4 do
         begin
              Str((Ord(COMi)+1),COM_tmp);
              COMx:='COM'+COM_tmp;
              Val(ParamStr(Tree),Speed,Code);       (*Prevadzam retazec z prikazoveho riadku na cislo*)
              if Exist_Str(COMx+'=',Upper(ParamStr(One)))=True then
                 begin
                      Val('$'+Erase_Str(COMx+'=',Upper(Erase_Str(' ',ParamStr(One)))),COM,Code);
                      COM_Addr[COMi]:=COM;
                 end;
              if COM_Addr[COMi]<>0 then WriteLn(COMx,' = ',Upper(HexStr(COM_Addr[COMi],SizeOf(COM_Addr[COMi]))+'h'));
              if Exist_Str(COMx,Upper(ParamStr(One)))=True then COM:=COM_Addr[COMi];
         end;
     for LPTi:=LPT1 to LPT3 do
         begin
              Str((Ord(LPTi)+1),LPT_tmp);
              LPTx:='LPT'+LPT_tmp;
              Val(ParamStr(3),Speed,Code);       (*Prevadzam retazec z prikazoveho riadku na cislo*)
              if Exist_Str(LPTx+'=',Upper(ParamStr(One)))=True then
                 begin
                      Val('$'+Erase_Str(LPTx+'=',Upper(Erase_Str(' ',ParamStr(One)))),COM,Code);
                      LPT_Addr[LPTi]:=COM;
                 end;
              if LPT_Addr[LPTi]<>0 then WriteLn(LPTx,' = ',Upper(HexStr(LPT_Addr[LPTi],SizeOf(LPT_Addr[LPTi]))+'h'));
              if Exist_Str(LPTx,Upper(ParamStr(One)))=True then COM:=LPT_Addr[LPTi];
         end;
     IRQ:=$FF;
     for IRQi:=IRQ0 to IRQ7 do
         begin
              Str(Ord(IRQi),IRQ_tmp);
              IRQx:='IRQ'+IRQ_tmp;
              if Exist_Str(IRQx,Upper(ParamStr(Two)))=True then
                 begin
                      if Exist_Str(IRQx,Upper(ParamStr(2)))=True then Val('$'+Erase_Str('IRQ',IRQx),IRQ,Code);
                 end;
         end;
     Ciarky;
{$IFDEF PROCESSOR}
     {$IFDEF ENGLISH}
     WriteLn('Processor: ',Zisti_CPU,'+',Zisti_NPU,', ',DosVer,Lo(DosVersion),'.',Hi(DosVersion),' in ',Zisti_Protect);
     {$ELSE}
     WriteLn('Procesor: ',Zisti_CPU,'+',Zisti_NPU,', ',DosVer,Lo(DosVersion),'.',Hi(DosVersion),' v ',Zisti_Protect);
     {$ENDIF}
{$ELSE}
     WriteLn(DosVer,Lo(DosVersion),'.',Hi(DosVersion));
{$ENDIF}
     Ciarky;
     WriteLn;
     if ((ParamCount<>3) or (COM=0) or (Speed=0) or (IRQ=$FF)) then
        begin
             COM:=COM_Addr[COM2];
             Speed:=2400;
             IRQ:=3;
             {$IFDEF ENGLISH}
             Writeln('No parameters on command line !');
             {$ELSE}
             Writeln('Chyba parameter na prikazovom riadku !');
             {$ENDIF}
             WriteLn(Upper(ParamStr(Zero)),' COM1 IRQ4 19200');
             WriteLn(Upper(ParamStr(Zero)),' COM2=2F8 IRQ3 2400');
             {$IFDEF ENGLISH}
             WriteLn('I have settings communications parameters:');
             {$ELSE}
             WriteLn('Mam nastavene tieto komunikacne parmetre:');
             {$ENDIF}
             WriteLn;
             WriteLn('Port  = ',Upper(HexStr(COM,SizeOf(COM))+'h'));
             WriteLn('IRQx  = ',Upper(HexStr(IRQ,SizeOf(IRQ))+'h'));
             WriteLn('Speed = ',Speed,'bps');
             WriteLn;
        end;
end;

{$IFDEF TIME}

procedure Time;
const Tab   : array [$00..$0F] of char = '0123456789ABCDEF';
      Base1 = 71;              (*Adresa offsetu pre zapis do VIDEORAM*)
      Base2 = $1F00;           (*DF00=D je pozadie, F je biela farba pisma, 00 je znak*)
      Base3 = 10;              (*Je delitel*)
procedure Vloz_Znak(Adresa:word;Atribute:word);
begin
     asm
{$IFDEF STACK}
        push es
        push di
        push dx
        push bx
        push ax
{$ENDIF}
        mov es,SegB800  (*Segmentova adresa videopamati*)
        mov di,Adresa   (*Offsetova adresa znaku vo videopamati*)
        cld             (*Priznak smeru spracovania*)
        mov bx,Atribute
        mov dx,3DAh     (*Citam stavovy register grafickej karty*)
@L1:    in al,dx        (*Cakam na spatny snimkovy beh luca vo VGA*)
        test al,01h     (*Nezobrazujem, zakaz ...*)
        loopnz @L1
@L2:    in al,dx        (*Cakam na spatny snimkovy beh luca vo VGA*)
        test al,01h     (*Nezobrazujem, zakaz ...*)
        jz @L2
        mov ax,bx       (*ES:DI=AX*)
        stosw           (*Ukladam do videopamati grafickej karty*)
{$IFDEF STACK}
        pop ax
        pop bx
        pop dx
        pop di
        pop es
{$ENDIF}
     end;
end;
procedure Desiatky(i:word; Cislo:byte); begin Vloz_Znak((Base1+i)*2,Base2 or Ord(Tab[Cislo div Base3])); end;
procedure Jednotky(i:word; Cislo:byte); begin Vloz_Znak((Base1+i)*2,Base2 or Ord(Tab[Cislo mod Base3])); end;
procedure Oddelovac(i:word; Znak:char); begin Vloz_Znak((Base1+i)*2,Base2 or Ord(Znak)); end;
begin
     Flag_Count:=Busy;
     if Sek>=60 then begin Sek:=0; Inc(Min); end;
     if Min>=60 then begin Min:=0; Inc(Hod); end;
     if Hod>=24 then Hod:=0;
     Jednotky(8,Sek);
     Desiatky(7,Sek);
     Oddelovac(6,':');
     Jednotky(5,Min);
     Desiatky(4,Min);
     Oddelovac(3,':');
     Jednotky(2,Hod);
     Desiatky(1,Hod);
end;

{$ENDIF}

procedure Terminal(Adresa:word);
const Escape  = 27;
      Enter   = #13;
var   Temp    : Retazec;
      Znak    : char;
label J1,J2;
begin
     Temp:='';
{$IFDEF MOBIL}
     Send(Adresa,'AT+CGMIV1E1+CGMM+CGMR+CGSN+GCAP+CCLK?+CBC+CSQ+CREG?'+Enter);         (*Spustam inicializacny retazec*)
{$ELSE}
     Send(Adresa,'ATE1V1X3%C3+FCLASS=0'+Enter);
{$ENDIF}
J1:  Port[Adresa+4]:=Port[Adresa+4] and not RTS;        (*Zakazem vysielanie*)
     Port[Adresa+4]:=Port[Adresa+4] or DTR;             (*Povolim prijmanie*)
     Repeat
           {$IFDEF TIME}
           if (Flag_Count=Free) and (VideoMode<>7) then Time;
           {$ENDIF}
           {$IFNDEF IRQ}
           while (Port[Adresa+5] and $01)=$01 do
                 begin
                      Znak:=Char(Port[Adresa]); Write(Znak); Answer:=Answer+Znak; (*Odpoved od modemu*)
                 end;
           {$ENDIF}
     Until KeyPressed;
     Znak:=ReadKey;                     (*Precitam prijaty znak ...*)
     if Znak=#0 then ReadKey;           (*Rozsirena klavesnica je vypnuta ...*)
     TextColor(LightRed);               (*Nastavim cervenu farbu AT prikazov ...*)
     Write(Znak);                       (*Vypisem znak na obrazovku z klavesnice ...*)
     TextColor(Yellow);                 (*Vypisem zltou farbou odpoved od modemu ...*)
     Case Znak of                       (*Dekodujem znaky stlacene z klavesnice*)
          'a'..'z','A'..'Z','0'..'9',
          '%','#','/','&','?','!','^',
          '*','/','+','-','=',';','>',
          '.','$','@','[',']',' '     : Temp:=Temp+Znak;
{$IFDEF MOBIL}
          ','                         : Send(Adresa,'ATD0904274542;'+Enter);
          '.'                         : Send(Adresa,'ATD>7;'+Enter);
          ''''                        : Send(Adresa,'AT+CCLK?'+Enter);
          '"'                         : Send(Adresa,'AT+CGMM'+Enter);
{$ELSE}
          ','                         : Send(Adresa,'AT&V'+Enter);
          ''''                        : Send(Adresa,'ATI4'+Enter);
          '"'                         : Send(Adresa,'ATI0'+Enter);
{$ENDIF}
          Enter                       : begin Temp:=Temp+Enter; Send(Adresa,Temp); Temp:=''; Answer:=''; end;
     else
         Temp:='';                    (*Prikaz neposielam a nezobrazujem !!!*)
     end;
     if Znak=Chr(Escape) then goto J2;
     goto J1;
J2:  Port[Adresa+4]:=Port[Adresa+4] or DTR;  (*Nastavim LED DTR=1 na modeme co umoznuje vysielanie vzdial. modemu*)
end;

{$IFDEF DATE}

procedure Datum;
{$IFDEF ENGLISH}
const Den : array [0..6] of Retazec = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
      Mes : array [1..12] of Retazec = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
{$ELSE}
const Den : array [0..6] of Retazec = ('Nedela','Pondelok','Utorok','Streda','Stvrtok','Piatok','Sobota');
      Mes : array [1..12] of Retazec = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Okt','Nov','Dec');
{$ENDIF}
var   Day,Month,Year : word;
      DayOfWeek      : word;
begin
     GetDate(Year,Month,Day,DayOfWeek);
{$IFDEF ENGLISH}
     WriteLn('Today ',Day,'.',Mes[Month],'.',Year,' is ',Lower(Den[DayOfWeek]));
{$ELSE}
     WriteLn('Dnes ',Day,'.',Mes[Month],'.',Year,' je ',Lower(Den[DayOfWeek]));
{$ENDIF}
end;

{$ENDIF}

begin
     Semafor:=Free;                     (*Nastavenie samaforu na volno...*)
{$IFDEF TIME}
     Flag_Count:=Free;
{$ENDIF}
     Dos_Busy:=Dos_Free;                (*Zistim obsadenost DOSu*)
     Temp_X:=WhereX;                    (*Odkladam poziciu kurzora na obrazovke*)
     Temp_Y:=WhereY;                    (*Odkladam poziciu kurzora na obrazovke*)
     Old_Scr:=New_Scr;                  (*Ulozim obsah obrazovky do pamati VIDEORAM ...*)
     HighVideo;                         (*Vypisujem vsetko s atributom Light*)
     DirectVideo:=True;                 (*Priamy pristup do pamati Video RAM*)
     CheckSnow:=True;                   (*Priamy pristup do pamati Video RAM*)
     CheckBreak:=False;                 (*True=Povolim CTRL+BREAK*)
     TextBackGround(Black);
     TextColor(Yellow);
     ClrScr;
     Logo;                              (*Vypisem moje logo na obrazovku*)
     Window(1,4,80,23);                 (*Vypisujem do okna*)
{$IFDEF DATE}
     Datum;
     Delay(10);
{$ENDIF}
     Zisti_COM(COM,IRQ,Speed);          (*Ktory port inicializujem, zistim z prikazoveho riadku ...*)
     Init_Port(COM,Speed);              (*Inicializujem port na pozadovanu rychlost ...*)
     LED:=LED or NumLock;               (*Nastavim klavesu NumLock do povodneho stavu ...*)
{$IFDEF IRQ}
     GetIntVec(IRQ+8,@TabIntVec[IRQ+8]);
     SetIntVec(IRQ+8,@New_Int_0Xh);     (*Nastavim novu obsluhu na moj univerzalny vektor prerusenia*)
     Enable_Interrupt(COM,IRQ);         (*Povolim generovanie prerusenia od linky IRQx*)
{$ENDIF}
{$IFDEF TIME}
     GetIntVec($08,@Old_Int_08h);
     SetIntVec($08,@New_Int_08h);
{$ENDIF}
{$IFDEF LED}
     GetIntVec($1C,@Old_Int_1Ch);
     SetIntVec($1C,@New_Int_1Ch);
{$ENDIF}
(**********************************************************************************************************************)
     Terminal(COM);                     (*Program obsluhujuci klavesnicu v rezime terminal ...*)
(**********************************************************************************************************************)
{$IFDEF IRQ}
     Disable_Interrupt(COM,IRQ);        (*Zakazem generovanie prerusenia od linky IRQx*)
     SetIntVec(IRQ+8,@TabIntVec[IRQ+8]);(*Vratim stary vektor prerusenia pre dokoncenie aplikacie*)
{$ENDIF}
{$IFDEF TIME}
     SetIntVec($08,@Old_Int_08h);
{$ENDIF}
{$IFDEF LED}
     SetIntVec($1C,@Old_Int_1Ch);
     LED:=LED and not ScrollLock;      (*Vratim klavesu Scroll do povodneho stavu ...*)
{$ENDIF}
     New_Scr:=Old_Scr;                 (*Obnovim obsah obrazovky do pamati ...*)
     TextColor(White);
     NormVideo;                        (*Obnovim rezim Video RAM*)
     Window(1,1,80,25);                (*Vypisujem do okna, potom musim vratit spat povodny rozmer okna*)
     LED:=LED or NumLock;              (*Vratim klavesu NumLock do povodneho stavu ...*)
     GotoXY(Temp_X,Temp_Y);            (*Obnovujem poziciu kurzora na obrazovke*)
end.