code segment word public

assume	cs:code

public cpu_id, protected,fpu_id

cpu8086		= 0
cpu80186	= 1
cpuv20		= 2
cpu80286	= 3
cpu80386sx	= 4
cpu80386dx	= 5
cpu80486sx	= 6
cpu80486dx	= 7
cpu80586	= 8
cpu80686	= 9

fpunone		= 0
fpu8087		= 1
fpu80287	= 2
fpu80387	= 3
fpu80487	= 4
fpu80587	= 5
emu80287	= 6
emu80387	= 7
emu80487	= 8

	SMART
	JUMPS

	.386p

;***************************************************
Store	macro
	irp Reg,<ebx,ecx,edx,edi,esp>
	push Reg
	endm
	endm
;***************************************************
Restore	macro
	irp Reg,<esp,edi,edx,ecx,ebx>
	pop Reg
	endm
	endm
;***************************************************
Null	macro
	irp Reg,<ebx,ecx,edx>
	xor Reg,Reg
	endm
	endm
;***************************************************

	.386p

cpu_id proc far
	Store
	mov ax,cpu80186
	push sp
	pop bx
	cmp bx,sp
	je cpu286
	mov cl,32
	shl bx,cl
	jnz cpukonec
	xor al,al
	mov al,40h
	mul al
	mov ax,cpu8086
	jnz cpukonec
	mov ax,cpuv20
	jmp cpukonec

cpu286:
	mov ax,0f000h
	push ax
	popf
	pushf
	pop ax
	and ax,0f000h
	jnz cpu386
	mov ax,cpu80286
	jmp cpukonec

cpu386:
	and esp,0ffffh
	mov edx,esp
	and esp,0fffch
	pushfd
	pop eax
	mov ecx,eax
	xor eax,40000h
	push eax
	popfd
	pushfd
	pop eax
	xor eax,ecx
	push ecx
	popfd
	mov esp,edx
	test eax,40000h
	jnz cpu486
	jmp cpu3sxdx

cpu486:
	pushfd
	pop eax
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	and eax,not 200000h	;Ked to tu nebolo hlasil sa po prvom spusteni ako 80486SX
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	mov ecx,eax
	or eax,200000h
	push eax
	popfd
	pushfd
	pop eax
	xor eax,ecx
	jnz cpu586
	mov ax,cpu80486sx
	jmp cpu4sxdx

	.586p
cpu586:
	mov eax,01h		;Volanie funkcie 01h pre CPUID
	Null
	cpuid			;db 0F,0D2h
	and eax,0f00h
	shr eax,08h
	cmp al,05h
	mov ax,cpu80486sx
	jl cpu4sxdx
	mov ax,cpu80586
;	jmp cpukonec

cpu686:
	mov eax,01h
	Null
	cpuid
	and eax,0f00h
	shr eax,08h
	cmp al,06h
	mov ax,cpu80586
	jl cpu4sxdx
	mov ax,cpu80686
	jmp cpukonec

cpu3sxdx:
	mov eax,12345678
	xor edx,edx
	xor edi,edi
	pushad
	popad
	mov ecx,[edx+edi]
	cmp eax,12345678
	mov ax,cpu80386sx
	je cpukonec
	mov ax,cpu80386dx
	jmp cpukonec

cpu4sxdx:
	.386p
	smsw bx
	and bx,02h
	jz cpukonec
	mov ax,cpu80486dx

cpukonec:
	Restore
	ret

cpu_id 	endp

protected proc far
	.386p
	smsw ax
	and ax,01h
	jz p1
	mov al,0ffh
	jmp p2
p1:	mov al,00h
p2:	ret
protected endp

fpu_cw dw ?
fpu_sw dw ?

fpu_id proc far
	push bx cx dx
	mov [fpu_cw],00h
	cli
	fninit
	mov cx,02h
	loop $
	fnstcw [fpu_cw]
	mov cx,14h
	loop $
	sti			
	mov ax,[fpu_cw]
	and ax,0f3fh
	cmp ax,033fh
	mov bx,fpunone
	jne fpukonec
	call cpu_id
	mov dx,ax
	cmp dx,cpu80286
	jge fpu287
	mov bx,fpu8087
	jmp fpukonec

	.386p
fpu287:
	smsw ax
	test al,04h
	mov cx,00h
	jz dalej
	mov cx,04h
dalej:	
	cmp dx,cpu80386sx
	jge fpu387
	mov bx,fpu80287
	jmp fpukonec
fpu387:
	cmp dx,cpu80486sx
	jge fpu487
	fld1
	fldz
	fdiv
	fld1
	fchs
	fldz
	fdiv
	fcompp
	fstsw [fpu_sw]
	mov ax,[fpu_sw]
	and ah,41h
	cmp ah,40h
	mov bx,fpu80287
	je fpukonec
	mov bx,fpu80387
	jmp fpukonec
fpu487:
	mov bx,fpu80487
	cmp dx,cpu80586
	jl fpukonec
	mov bx,fpu80587
fpukonec:
	mov ax,bx
	add ax,cx
	pop dx cx bx
	ret

fpu_id  endp

code	ends
	end